#ifndef SUBGRAPHMINERNAUTY_H
#define SUBGRAPHMINERNAUTY_H

#include "File.h"
#include "Sumgra.h"
#include "Frequency.h"
#include "Mis.h"
#include "GraphIso.h"
#include "TracesIso.h"
#include <../sumgra/Trie.h>

struct Canonical{
    Set2D multiEdges;
    sparsegraph subgraph;
};

//typedef std::map<int, std::vector<sparsegraph>> IsoMeasureNauty;
typedef std::map<int, std::vector<Canonical>> IsoMeasure;

//struct TimeEval{
//    double SgExt = 0;
//    double SgFrq = 0;
//    double EmbEv = 0;
//};

class SubgraphMinerNauty
{
    public:
        SubgraphMinerNauty();
        virtual ~SubgraphMinerNauty();
        void RetrieveAllItems(std::set<int> inputSet, VecOfSet& allSubsets);
        void CollectAllDataEdges(const std::map<std::set<int>, int>& distinctDataEdges, std::set<std::set<int>>& distinctEdges);
        void CollectSubgraphSeeds(const GraphParameter& dataGraphInfo, std::deque<Subgraph>& subgraphSeeds);
        void CollectFSG(const int& sSize, const std::deque<Subgraph> newFSGs, std::map<int, std::deque<FSG>>& allFSG);
        void ExtractInfo(const Subgraph& subgraph, GraphParameter& subgraphInfo);
        void MineFrequentSubgraphs(const GraphParameter& dataGraphInfo, IndexType& graphIndexes, const int& supportVal, std::map<int, std::deque<FSG>>& allFSG);
        void SubgraphExtension(const IsoTestMap& dataGraph, Subgraph& oldFSG, const std::set<int>& newEdge, IsoMeasure& canonicalAllLevel, const int& supportVal, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, std::deque<Subgraph>& newFSGs);

        void FindFrequentSeeds(const int& supportVal, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, std::deque<Subgraph>& newSubgraphs, std::deque<Subgraph>& newFSGs);
//        void FindFrequentSubgraphs(TimeEval& timeEval, const std::set<int> newEdge, const int& supportVal, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, Subgraph& oldFSG, std::deque<Subgraph>& newSubgraphs, std::deque<Subgraph>& newFSGs);

//        bool IsNotIsomorphicCurrentNauty(Subgraph& newSubgraph, std::vector<sparsegraph>& extraNodeCanonical, const IsoTestMap& dataGraph);
//        bool IsNotIsomorphicPreviousNauty(const int& subgraphSize, sparsegraph& canonical,  IsoMeasureNauty& canonicalAllLevel);
        bool IsNotIsomorphicCurrentNauty(Subgraph& newSubgraph, std::vector<Canonical>& canonicalSet, const IsoTestMap& dataGraph);
        bool IsNotIsomorphicPreviousNauty(const int& subgraphSize, Canonical& canonicalForm,  IsoMeasure& canonicalAllLevel);

        bool IsFrequent(const int& supportVal, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, Subgraph& newSubgraph);
        bool InvalidTrieEdge(Trie* trie, std::set<int> newEdge);
        void DfsRecursiveMining(StackFSG& fsgClassStack, IsoMeasure& canonicalAllLevel, std::deque<Subgraph>& extendableEdges, int nE, TimeEval& timeEval, const IsoTestMap& dataGraph, const int& supportVal, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, std::map<int, std::deque<FSG>>& allFSG, int& noOfFsg);
    protected:
    private:

};

#endif // SUBGRAPHMINERNAUTY_H
