#ifndef SUMGRA_H
#define SUMGRA_H

#include "File.h"
#include "../sumgra/Index.h"
#include "../sumgra/Match.h"

#define MAX_ALLOWED_TIME 0.1 // in seconds; when an embedding is not found stop recursing the tree depth at this stage
#define TOTAL_MAX_ALLOWED_TIME 60 // in seconds

// values for hopcroft maximum matching algorithm
//const int MAXN1 = 500000;
//const int MAXN2 = 500000;
//const int MAXM = 1000000;
//

struct IndexType{
    AttMap attributeHash;
    RTree synopsesTrie;
    std::vector<Trie*> neighborTrie;
//    IndexType() : dataBitSet(dataGraphInfo.nNodes) {}
//    EdgeLabelBit dataBitSet;
};

class Sumgra
{
    public:
        Sumgra();
        virtual ~Sumgra();
        void BuildIndexes(GraphParameter& dataGraphInfo, IndexType& graphIndexes);
        bool FindEmbeddings(const int& freq, const GraphParameter& queryGraphInfo, const GraphParameter& dataGraphInfo, IndexType& graphIndexes, Subgraph& matchedSubgraph);
        bool FindEmbeddingsMNI(const int& freq, GraphParameter& queryGraphInfo, const GraphParameter& dataGraphInfo, IndexType& indexType, Subgraph& matchedSubgraph);
        bool FindIsoMatch(Subgraph& query, IndexType& indexType, Vector2D& solutions);
    protected:
    private:
};

#endif // SUMGRA_H
