#include "Mis.h"

Mis::Mis()
{
    //ctor
}

Mis::~Mis()
{
    //dtor
}

bool removable(vector<int> neighbor, vector<int> cover)
{
 bool check=true;
 for(int i=0; i<neighbor.size(); i++)
 if(cover[neighbor[i]]==0)
 {
  check=false;
  break;
 }
 return check;
}

int max_removable(vector<vector<int> > neighbors, vector<int> cover)
{
 int r=-1, max=-1;
 for(int i=0; i<cover.size(); i++)
 {
  if(cover[i]==1 && removable(neighbors[i],cover)==true)
  {
   vector<int> temp_cover=cover;
   temp_cover[i]=0;
   int sum=0;
   for(int j=0; j<temp_cover.size(); j++)
   if(temp_cover[j]==1 && removable(neighbors[j], temp_cover)==true)
   sum++;
   if(sum>max)
   {
    if(r==-1)
    {
     max=sum;
     r=i;
    }
    else if(neighbors[r].size()>=neighbors[i].size())
    {
     max=sum;
     r=i;
    }
   }
  }
 }
 return r;
}

vector<int> procedure_1(vector<vector<int> > neighbors, vector<int> cover)
{
 vector<int> temp_cover=cover;
 int r=0;
 while(r!=-1)
 {
  r= max_removable(neighbors,temp_cover);
  if(r!=-1) temp_cover[r]=0;
 }
 return temp_cover;
}

vector<int> procedure_2(vector<vector<int> > neighbors, vector<int> cover, int k)
{
 int count=0;
 vector<int> temp_cover=cover;
 int i=0;
 for(int i=0; i<temp_cover.size(); i++)
 {
  if(temp_cover[i]==1)
  {
   int sum=0, index;
   for(int j=0; j<neighbors[i].size(); j++)
   if(temp_cover[neighbors[i][j]]==0) {index=j; sum++;}
   if(sum==1 && cover[neighbors[i][index]]==0)
   {
    temp_cover[neighbors[i][index]]=1;
    temp_cover[i]=0;
    temp_cover=procedure_1(neighbors,temp_cover);
    count++;
   }
   if(count>k) break;
  }
 }
 return temp_cover;
}

int cover_size(vector<int> cover)
{
 int count=0;
 for(int i=0; i<cover.size(); i++)
 if(cover[i]==1) count++;
 return count;
}



void Mis::FindMis(const Vector2D& adjacencyList, const int& freq, int& independenceNo)
{
    int i, j, k, p, q, r, s, minS, edge, counter=0;
    int n = adjacencyList.size();
    k=n-freq;

    bool found=false;
    minS=n+1;
    Vector2D covers;
    std::vector<int> allcover;
    for(i=0; i<n; i++)
        allcover.push_back(1);
    for(i=0; i<allcover.size(); i++){
        if(found)
            break;
        counter++;
        std::vector<int> cover = allcover;
        cover[i]=0;
        cover=procedure_1(adjacencyList,cover);
        s=cover_size(cover);
        if(s<minS)
            minS=s;
        if(s<=k){
            //   cout<<"Independent Set ("<<n-s<<"): ";
            /// Collect MIS.
            /*
            for(j=0; j<cover.size(); j++){
                if(cover[j]==0){
                    maxIndSet.push_back(j+1);
                    //        cout<<j+1<<" ";
                }
            }
            */
            covers.push_back(cover);
            found=true;
            break;
        }
        for(j=0; j<n-k; j++)
            cover=procedure_2(adjacencyList,cover,j);
        s=cover_size(cover);
        if(s<minS)
            minS=s;
        /// Collect MIS
        /*
        for(j=0; j<cover.size(); j++) {
            if(cover[j]==0){
                maxIndSet.push_back(j+1);
//                cout<<j+1<<" ";
            }
        }
        */
        covers.push_back(cover);
        if(s<=k){
            found=true;
            break;
        }
    }

//    if(found) cout<<"Found Independent Set of size at least "<<freq<<"."<<endl;
//    else cout<<"Could not find Independent Set of size at least "<<freq<<"."<<endl
    independenceNo = n-minS; // Independence number for a graph G for a discovered maximum independent set |
//    cout <<"Maximum Independent Set " <<n-minS << "." <<endl;
}
