#include "SpectralSignature.h"

SpectralSignature::SpectralSignature()
{
    //ctor
}

SpectralSignature::~SpectralSignature()
{
    //dtor
}

bool CompareDoubleArrays(std::array<double, 3> a, std::array<double, 3> b){

    for(int t = 0; t < a.size(); ++t){
        if(fabs(a[t]-b[t]) > EPSILON){
            return false;
        }
    }
    return true;
}

void SpectralSignature::ComputeSignature(int a){
//MatrixXd A = MatrixXd::Random(6,6);
int n = 4;
 MatrixXd A(n,n);
 MatrixXd AD(n,n);
/*
  A(0,0) = 2;
  A(0,1) = -1;
  A(0,2) = -1;
  A(1,0) = -1;
  A(1,1) = 2;
  A(1,2) = -1;
  A(2,0) = -1;
  A(2,1) = -1;
  A(2,2) = 2;

  AD(0,0) = 2;
  AD(0,1) = 0;
  AD(0,2) = 0;
  AD(1,0) = 0;
  AD(1,1) = 2;
  AD(1,2) = 0;
  AD(2,0) = 0;
  AD(2,1) = 0;
  AD(2,2) = 2;
  */

  A(0,0) = 1;
  A(0,1) = -1;
  A(0,2) = 0;
  A(0,3) = 0;
  A(1,0) = -1;
  A(1,1) = 3;
  A(1,2) = -1;
  A(1,3) = -1;
  A(2,0) = 0;
  A(2,1) = -1;
  A(2,2) = 1;
  A(2,3) = 0;
  A(3,0) = 0;
  A(3,1) = -1;
  A(3,2) = 0;
  A(3,3) = 1;

  AD(0,0) = 1;
  AD(0,1) = 0;
  AD(0,2) = 0;
  AD(0,3) = 0;
  AD(1,0) = 0;
  AD(1,1) = 3;
  AD(1,2) = 0;
  AD(1,3) = 0;
  AD(2,0) = 0;
  AD(2,1) = 0;
  AD(2,2) = 1;
  AD(2,3) = 0;
  AD(3,0) = 0;
  AD(3,1) = 0;
  AD(3,2) = 0;
  AD(3,3) = 1;

cout << "Graph A:" << endl << A << endl << endl;
//cout << "Normalized A:" << endl << AD.pow(-0.5)*A*AD.pow(-0.5)<< endl << endl;

A=AD.pow(-0.5)*A*AD.pow(-0.5);

EigenSolver<MatrixXd> es(A);
//MatrixXd C = es.pseudoEigenvalueMatrix();
//std::array<double, 3> arrA;
double *arrA = new double[n];
MatrixXd hksA(1,1);




MatrixXd esAbs = es.pseudoEigenvectors().cwiseAbs();
MatrixXd eValAbs = es.pseudoEigenvalueMatrix().cwiseAbs();
//MatrixXd esAbs = es.pseudoEigenvectors();
//MatrixXd eValAbs = es.pseudoEigenvalueMatrix();

cout << "The eigenvalue matrix :" << endl << eValAbs << endl;
cout << "The eigenvector matrix: " << endl << esAbs << endl << endl;

for(int t = 1; t < n+1; ++t){
    hksA(0,0) = 0;
    for(size_t i =0; i < n; ++i){
        double lambda [1];
        Map<MatrixXd>(lambda,1,1) = eValAbs.row(i).col(i);
        hksA += exp(-t*lambda[0])*(esAbs.col(i).transpose()*esAbs.col(i));
        cout << "prod: " << esAbs.col(i).transpose()*esAbs.col(i) << endl;
    }
    Map<MatrixXd>(&arrA[t-1],1,1) = hksA;
//    cout << "hks: A[" << t << "]: "  << arrA[t-1] << endl;
}
delete[] arrA;
arrA = nullptr;

/// Compute automorphic group.
// Get eigenvalues:
//double lambda [3];
double *lambda = new double[n];
for(int i = 0; i < n; ++i)
    Map<MatrixXd>(&lambda[i],1,1) = eValAbs.row(i).col(i);

MatrixXd hksAll(1,1);
ofstream fout;
fout.open("/home/vijay/Desktop/hksMatrix.txt");
for(int i = 0; i < n; ++i){
    for(int j = 0; j < n; ++j){
    //    if(i != j){ // do not compute diagonal values of HKS matrix |
        MatrixXd prod = esAbs.col(i).transpose()*esAbs.col(j);
        cout << endl << "Vertex pairs: " << i << ", " << j << endl;
        cout << "Prod: " << prod << endl;
    //    std::array<double, 3> arrAll;
        double *arrAll = new double[n];
        for(int t = 0; t < n; ++t){
            hksAll(0,0) = 0;
            for(int v = 0; v < n; ++v)
                hksAll += exp(-t*lambda[v])*prod;
            Map<MatrixXd>(&arrAll[t],1,1) = hksAll;
        }
        for(int t = 0; t < n; ++t){
            cout << arrAll[t] << ", " ;
            fout << arrAll[t] << ", " ;
        }
        cout << endl;
        fout << "\t";
        delete[] arrAll;
        arrAll = nullptr;
    //    }
    }
    cout << endl;
    fout << endl << endl;
}
delete[] lambda;
lambda = nullptr;
fout.close();
/*
cout << endl << endl;

 MatrixXd B(3,3);
  B(0,0) = 1;
  B(0,1) = -1;
  B(0,2) = 0;
  B(1,0) = -1;
  B(1,1) = 1;
  B(1,2) = -1;
  B(2,0) = 0;
  B(2,1) = -1;
  B(2,2) = 1;

 MatrixXd BD(3,3);
  BD(0,0) = 1;
  BD(0,1) = 0;
  BD(0,2) = 0;
  BD(1,0) = 0;
  BD(1,1) = 2;
  BD(1,2) = 0; //0
  BD(2,0) = 0;
  BD(2,1) = 0; //0
  BD(2,2) = 1;
cout << "Graph B:" << endl << B << endl << endl;
//cout << "Normalized graph:" << endl << BD.pow(-0.5)*B*BD.pow(-0.5) << endl << endl;

B=BD.pow(-0.5)*B*BD.pow(-0.5);
EigenSolver<MatrixXd> esB(B);
MatrixXd D = esB.pseudoEigenvalueMatrix();
//double arr [3];
std::array<double, 3> arr;
MatrixXd hks(1,1);
//cout << "The eigenvalue matrix of B are:" << endl << esB.pseudoEigenvalueMatrix() << endl;
//cout << "The eigenvector matrix: " << endl << esB.pseudoEigenvectors() << endl << endl;

for(int t = 1; t < 4; ++t){
    hks(0,0) = 0;
    for(size_t i =0; i < 3; ++i){
        double lambda [1];
        Map<MatrixXd>(lambda,1,1) = esB.pseudoEigenvalueMatrix().row(i).col(i);
        hks += exp(-t*lambda[0])*(esB.pseudoEigenvectors().col(i).transpose()*esB.pseudoEigenvectors().col(i));
//        cout << "prod: " << esB.pseudoEigenvectors().col(i).transpose()*esB.pseudoEigenvectors().col(i) << endl;
    }
    Map<MatrixXd>(&arr[t-1],1,1) = hks;
    cout << "hks: B[" << t << "]: "  << arr[t-1] << endl;
}
//cout << arrA.size() << ", " << arr.size() << endl;


if (CompareDoubleArrays(arr, arrA))
    cout << endl << "Graphs are ISOMORPHIC" << endl;
else
    cout << "Graphs are NOT isomorphic" << endl;

*/


//double sc = esB.pseudoEigenvalueMatrix().row(0).col(0).cast <double> ();
//cout << "The first eigenvector is:" << endl << esB.eigenvectors().col(1) << endl << endl;
//cout << "The transpose of first eigenvector is:" << endl << esB.eigenvectors().col(1).transpose() << endl << endl;
//cout << "Product: " << esB.eigenvectors().col(1).transpose()*esB.eigenvectors().col(1) << endl;

}
