#include "TracesIso.h"

TracesIso::TracesIso()
{
    //ctor
}

TracesIso::~TracesIso()
{
    //dtor
}


void TracesIso::CheckIsoSimple()
{
    DYNALLSTAT(int,lab1,lab1_sz);
    DYNALLSTAT(int,lab2,lab2_sz);
    DYNALLSTAT(int,ptn,ptn_sz);
    DYNALLSTAT(int,orbits,orbits_sz);
    DYNALLSTAT(int,map,map_sz);

/// TRACES
//    static DEFAULTOPTIONS_TRACES(options);
//    TracesStats stats;

/// NAUTY
    static DEFAULTOPTIONS_SPARSEGRAPH(options);
    statsblk stats;

    int n,m,i;

 /* Select option for canonical labelling */

    options.getcanon = TRUE;

    n = 3;
    m = SETWORDSNEEDED(n);
    nauty_check(WORDSIZE,m,n,NAUTYVERSIONID);

    DYNALLOC1(int,lab1,lab1_sz,n,"malloc");
    DYNALLOC1(int,lab2,lab2_sz,n,"malloc");
    DYNALLOC1(int,ptn,ptn_sz,n,"malloc");
    DYNALLOC1(int,orbits,orbits_sz,n,"malloc");
    DYNALLOC1(int,map,map_sz,n,"malloc");

/// Generate your own graphs
// A triangle graph
/*
    DYNALLSTAT(int,lab3,lab3_sz);
    SG_DECL(sg3); SG_DECL(cg3);
    SG_ALLOC(sg3,n,2*n,"malloc");
    sg3.nv = n;
    sg3.nde = 2*n;

    for (i = 0; i < n; ++i)
    {
      sg3.v[i] = 2*i;
      sg3.d[i] = 2;
      sg3.e[2*i] = (i+n-1)%n;
      sg3.e[2*i+1] = (i+n+1)%n;
    }
*/

// A wedge graph (enumeration-1)
    DYNALLSTAT(int,lab3,lab3_sz);
    // Declare and initialize sparse graph structures
    SG_DECL(sg3); SG_DECL(cg3);
    SG_ALLOC(sg3,n,4,"malloc");
    sg3.nv = n;
    sg3.nde = 4;

    sg3.v[0] = 0; sg3.v[1] = 2; sg3.v[2] = 4;
    sg3.d[0] = 1; sg3.d[1] = 1; sg3.d[2] = 2;
    sg3.e[0] = 2; sg3.e[2] = 2; sg3.e[4] = 0; sg3.e[5] = 1;


// A wedge graph (enumeration-2)
    DYNALLSTAT(int,lab4,lab4_sz);
    SG_DECL(sg4); SG_DECL(cg4);
    SG_ALLOC(sg4,n,4,"malloc");
    sg4.nv = n;
    sg4.nde = 4;

    sg4.v[0] = 0; sg4.v[1] = 3; sg4.v[2] = 5;
    sg4.d[0] = 2; sg4.d[1] = 1; sg4.d[2] = 1;
    sg4.e[0] = 1; sg4.e[1] = 2; sg4.e[3] = 0; sg4.e[5] = 0;

// Compute canonical representations;

//    Traces(&sg3,lab1,ptn,orbits,&options,&stats,&cg3);
//    Traces(&sg4,lab2,ptn,orbits,&options,&stats,&cg4);

    sparsenauty(&sg3,lab1,ptn,orbits,&options,&stats,&cg3);
    sparsenauty(&sg4,lab2,ptn,orbits,&options,&stats,&cg4);

 // Compare canonically labelled graphs
    if (aresame_sg(&cg3,&cg4))
    {
        printf("Isomorphic.\n");
        if (n <= 1000)
        {
         // Write the isomorphism.  For each i, vertex lab1[i] of sg1 maps onto vertex lab2[i] of sg2.  We compute the map in order of labelling because it looks better. //
            for (i = 0; i < n; ++i) map[lab1[i]] = lab2[i];
            for (i = 0; i < n; ++i) printf(" %d-%d",i,map[i]);
            printf("\n");
        }
    }
    else
        printf("Not isomorphic.\n");
}

void TracesIso::CheckIso()
{
    DYNALLSTAT(int,lab1,lab1_sz);
    DYNALLSTAT(int,lab2,lab2_sz);
    DYNALLSTAT(int,ptn,ptn_sz);
    DYNALLSTAT(int,orbits,orbits_sz);
    DYNALLSTAT(int,map,map_sz);

/// TRACES
//    static DEFAULTOPTIONS_TRACES(options);
//    TracesStats stats;

/// NAUTY
    static DEFAULTOPTIONS_SPARSEGRAPH(options);
    statsblk stats;

    int n,m,i;

 /* Select option for canonical labelling */

    options.getcanon = TRUE;

    n = 6;
    m = SETWORDSNEEDED(n);
    nauty_check(WORDSIZE,m,n,NAUTYVERSIONID);

    DYNALLOC1(int,lab1,lab1_sz,n,"malloc");
    DYNALLOC1(int,lab2,lab2_sz,n,"malloc");
    DYNALLOC1(int,ptn,ptn_sz,n,"malloc");
    DYNALLOC1(int,orbits,orbits_sz,n,"malloc");
    DYNALLOC1(int,map,map_sz,n,"malloc");

/// Generate your own graphs
// A triangle graph
/*
    DYNALLSTAT(int,lab3,lab3_sz);
    SG_DECL(sg3); SG_DECL(cg3);
    SG_ALLOC(sg3,n,2*n,"malloc");
    sg3.nv = n;
    sg3.nde = 2*n;

    for (i = 0; i < n; ++i)
    {
      sg3.v[i] = 2*i;
      sg3.d[i] = 2;
      sg3.e[2*i] = (i+n-1)%n;
      sg3.e[2*i+1] = (i+n+1)%n;
    }
*/

sparsegraph sg; // Declare sparse graph structure

// A wedge graph (enumeration-1)
    DYNALLSTAT(int,lab3,lab3_sz);
    SG_DECL(sg3); SG_DECL(cg3);
    SG_ALLOC(sg3,n,15,"malloc");
    sg3.nv = n;
    sg3.nde = 15;

    sg3.v[0] = 0; sg3.v[1] = 2; sg3.v[2] = 5; sg3.v[3] = 8; sg3.v[4] = 11; sg3.v[5] = 13;
    sg3.d[0] = 1; sg3.d[1] = 2; sg3.d[2] = 2; sg3.d[3] = 2; sg3.d[4] = 1; sg3.d[5] = 2;
    sg3.e[0] = 3; sg3.e[2] = 2; sg3.e[3] = 4; sg3.e[5] = 1; sg3.e[6] = 5; sg3.e[8] = 0; sg3.e[9] = 5; sg3.e[11] = 1; sg3.e[13] = 2; sg3.e[14] = 3;


// A wedge graph (enumeration-2)
    DYNALLSTAT(int,lab4,lab4_sz);
    SG_DECL(sg4); SG_DECL(cg4);
    SG_ALLOC(sg4,n,15,"malloc");
    sg4.nv = n;
    sg4.nde = 15;

    sg4.d[0] = 2; sg4.d[1] = 1; sg4.d[2] = 2; sg4.d[3] = 2; sg4.d[4] = 2; sg4.d[5] = 1;
    sg4.v[0] = 0; sg4.v[1] = 3; sg4.v[2] = 5; sg4.v[3] = 8; sg4.v[4] = 11; sg4.v[5] = 14;
    sg4.e[0] = 2; sg4.e[1] = 3; sg4.e[3] = 4; sg4.e[5] = 0; sg4.e[6] = 5; sg4.e[8] = 0; sg4.e[9] = 4; sg4.e[11] = 1; sg4.e[12] = 3; sg4.e[14] = 2;

// Compute canonical representations;

//    Traces(&sg3,lab1,ptn,orbits,&options,&stats,&cg3);
//    Traces(&sg4,lab2,ptn,orbits,&options,&stats,&cg4);

    sparsenauty(&sg3,lab1,ptn,orbits,&options,&stats,&cg3);
    sparsenauty(&sg4,lab2,ptn,orbits,&options,&stats,&cg4);

for (i = 0; i < n; ++i)
    printf(" %d ", lab1[i]);
printf("\n");
for (i = 0; i < n; ++i)
    printf(" %d ", lab2[i]);
printf("\n");
 // Compare canonically labelled graphs
    if (aresame_sg(&cg3,&cg4))
    {
        printf("Isomorphic.\n");
        if (n <= 1000)
        {
         // Write the isomorphism.  For each i, vertex lab1[i] of sg1 maps onto vertex lab2[i] of sg2.  We compute the map in order of labelling because it looks better. //
            for (i = 0; i < n; ++i) map[lab1[i]] = lab2[i];
            for (i = 0; i < n; ++i) printf(" %d-%d",i,map[i]);
            printf("\n");
        }
    }
    else
        printf("Not isomorphic.\n");
}


void TracesIso::NautyReadableSG(const Vector2D& adjacencyList, sparsegraph& xsg)
{
    int n = adjacencyList.size(); // # nodes |
    int xsgSize = 0;
    for(int i = 0; i < n; ++i){
        xsgSize += adjacencyList[i].size();
    }
    xsgSize+=n;
    // Initialize graphs
//cout << "n: " << n << ";  xsgSize: " << xsgSize << endl;
    SG_ALLOC(xsg,n,xsgSize,"malloc");
    xsg.nv = n;
    xsg.nde = xsgSize;
    //
//cout << "D: " << endl;
    for(int i = 0; i < n; ++i){
        xsg.d[i] = adjacencyList[i].size();
//cout << xsg.d[i] << ", ";
    }
    xsg.v[0] = 0;
//cout << endl << "V: "<< endl;
    for(int i = 0; i < n-1; ++i){
        xsg.v[i+1] = xsg.v[i] + xsg.d[i] + 1;
//cout << xsg.v[i+1] << ", ";
    }
//cout << endl << "E: " << endl;
    int pivot = 0;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < adjacencyList[i].size(); ++j){
            xsg.e[pivot] = adjacencyList[i][j];
//cout << "e[" << pivot << "]: " << adjacencyList[i][j] << ", ";
            ++pivot;
        }
        ++pivot;
    }
//cout << endl;
}

/*
struct Subgraph{
    EdgeLabelMap edgeLabels;
    NodeLabelMap nodeLabels;
    std::vector<int> orderedNodes;
    Vector2D embeddings;
    std::vector<int> canonicalForm;
    SG_DECL(canonicalNauty);
    Set2D multiEdges; // set collection of the set of all multiedges of each generated frequent subgraph |
    int frequency;
    GraphParameter parameters;
    Set2D nonFreqEdges;
    bool alreadyExtended = false;
    std::map<int, Set2D> nonFreqEdgesN;
    std::map<PairInt, Set2D> nonFreqEdgesE;
    bool nonFreqEdgeExists = false;
    Trie* nonFreqEdge;
    std::map<int, Trie*> nonFreqEdgeN;
    std::map<PairInt, Trie*> nonFreqEdgeE;
};
*/

void TracesIso::TransformSG(const Subgraph& subgraph, sparsegraph& xsg, int& n)
{
    int nETypes = subgraph.multiEdges.size();
    int nLayers = floor(log2(nETypes)) + 1;
    int origN = subgraph.parameters.nNodes;
    n = origN * nLayers; // New nodes |

//    cout << nETypes << ", " << nLayers << ", " << origN << ", " << n << endl;

    if(nLayers == 1){ // Represent the ORIGINAL graph in nauty format |
        Vector2D adjacencyList = subgraph.parameters.adjacencyList;
        NautyReadableSG(adjacencyList, xsg);
    }
    else{ // Represent the TRANSFORMED graph in nauty format |
    /// Add the directed edges from layer 0 to layer n.
        Vector2D adjacencyListExtd(n);
        int pivot = 0;
        for(int l = 0; l < nLayers - 1; ++l){
            for(int i = 0; i < origN; ++i){
                adjacencyListExtd[pivot+i].push_back(pivot + origN +i);
//                adjacencyListExtd[pivot + origN +i].push_back(pivot +i);
            }
            pivot+=origN;
        }

    /// Add the undirected edges within each layers.
        /// Get reverse mapping for edge types.
        std::map<std::set<int>, std::vector<std::pair<int, int>>> uniqueETypeMap;
        for(auto it = subgraph.parameters.eLabelMap.begin(); it != subgraph.parameters.eLabelMap.end(); ++it){
            auto itF = uniqueETypeMap.find(it->second);
            if (itF == uniqueETypeMap.end()){
                std::vector<std::pair<int, int>> tempVec;
                tempVec.push_back(it->first);
                uniqueETypeMap.insert(std::make_pair(it->second, tempVec));
            }
            else
                itF->second.push_back(it->first);
        }
        /// Represent each integer layer as a binary value and add the edge to the layer it belongs |
        auto it = uniqueETypeMap.begin();
        for(int e = 0; e < nETypes; ++e){
            std::bitset<10> binLayer(e+1);
            int pivot = 0;
            for(int l = 0; l < nLayers; ++l){
                if(binLayer[l]){ // add the edge type to layer 'l' for the relevant nodes |
                    for(int i = 0; i < it->second.size(); ++i){
                        /// Add the undirected edge
                        adjacencyListExtd[pivot+it->second[i].first].push_back(pivot + it->second[i].second);
//                        adjacencyListExtd[pivot+it->second[i].second].push_back(pivot + it->second[i].first);
                    }
                }
                pivot+=origN;
            }
            ++it;
        }
        NautyReadableSG(adjacencyListExtd, xsg);

//        for(size_t i = 0; i < adjacencyListExtd.size(); ++i){
//            for(size_t j = 0; j < adjacencyListExtd[i].size(); ++j)
//                cout << adjacencyListExtd[i][j] << ", ";
//            cout << endl;
//        }
//        cout << "***" << endl;
    }
}

void TracesIso::GenerateCanonical(Subgraph& subgraph)
{
    /// Convert the multigraph into a Traces/nauty readable simple graph
    SG_DECL(xsg); // Original multigraph extended to a simple graph 'xsg'.
    int n;
    TransformSG(subgraph, xsg, n);

    DYNALLSTAT(int,lab,lab_sz);
    DYNALLSTAT(int,ptn,ptn_sz);
    DYNALLSTAT(int,orbits,orbits_sz);
    DYNALLSTAT(int,map,map_sz);

/// TRACES
//    static DEFAULTOPTIONS_TRACES(options);
//    TracesStats stats;

/// NAUTY
    static DEFAULTOPTIONS_SPARSEGRAPH(options);
    statsblk stats;

    options.getcanon = TRUE;
    int m = SETWORDSNEEDED(n);
    nauty_check(WORDSIZE,m,n,NAUTYVERSIONID);

    DYNALLOC1(int,lab,lab_sz,n,"malloc");
    DYNALLOC1(int,ptn,ptn_sz,n,"malloc");
    DYNALLOC1(int,orbits,orbits_sz,n,"malloc");
    DYNALLOC1(int,map,map_sz,n,"malloc");

/// Compute canonical representation;
    sparsenauty(&xsg,lab,ptn,orbits,&options,&stats,&subgraph.canonicalNauty);
//    Traces(&xsg,lab,ptn,orbits,&options,&stats,&subgraph.canonicalNauty);

//    for (int i = 0; i < n; ++i) printf(" %d-%d",i,lab[i]);
//    printf("\n");

}

